	/**
	* Control
	* @param gui
	*/
	Control = function Control(gui) {
		var upnp;
		var servers = [];
		var players = [];
		var disconnected = [];
		var content = [];
		var folder = -1;
		var history = [];
		var groups = [];
		var select = [];
		var memberselect = [];
		var playselect = [];
		var duration;
		var position = 0;
		var contentxml;
		var current = 0;
		var playlist_total_count = 0;
		var server;
		var group;

      var _uri;
      var timevis = GetItem(gui.timevis);
		var _event;
		var radiocallback;
		var list;
		var grouplist;
		var selected_zone = 0;
		var volume_group_list;
		var playlist;
		var memberlist;
		var gplaylist;
      var back = GetItem(gui.back);
		var play;
		var track;
      var filter = GetItem(gui.filter);
		var artist;
		var album;
		var art;
		var volume;
		var percent;
		var mute;
		var zone;
		var shuffle;
		var repeat;
		var glist;
		var timeline;
		var timeleft;
		var timepast;
      var pren = true;
		var name;
		var letters = [];
		var curletter;
		var favorites;
		var remove;
		var radio;
		var deezer;
		var _content = [];
		var updating;

		var modes = ["NORMAL", "REPEAT_ALL", "SHUFFLE_NOREPEAT", "SHUFFLE"];
		var date = new Date();
		var date2 = new Date();

		var group_created = false; // parse data in RecieveEvents only after update group ending
		var deezer_buffer = ''; // buffer for intermediate Deezer data

		var player_volume = 0;

      /**
		 * Hide back
		 * @return {in_time}
		 */
		function HideBack(in_time){
			back.Visible = false;
			pren = false;
			IR.SetTimeout(in_time || 3000, function(){
				if(!pren)
					back.Visible = true;
			})
		}
      
      /**
		 * escape HTML
		 * @param {s}
		 * @param {l}
		 * @return {String}
		 */
      var escapeHTML = (function () {
			var Lvl;
			var MAP = {
				'&': '&amp;',
				'<': '&lt;',
				'>': '&gt;',
				'"': '&#34;',
				"'": '&#39;'
			};
			var repl = function (c) {
				if(Lvl > 0){
					var _Lvl = Lvl - 1;
					var _l = "&amp;";
					while(--_Lvl >= 0){
						_l+="amp;"
					}
					return _l + MAP[c].substring(1);
				}
				return MAP[c];
			};
			return function (s, l) {
				Lvl = l || 0;			
				return s.replace(/[&<>'"]/g, repl);
			};
		})()
      
      /**
		 * html special chars decode
		 * @param {string}
		 * @param {quote_style}
		 * @return {String}
		 */
      function htmlspecialchars_decode(string, quote_style) {
		  var optTemp = 0,
			i = 0,
			noquotes = false;
		  if (typeof quote_style === 'undefined') {
			quote_style = 2;
		  }
		  string = string.toString()
			.replace(/&lt;/g, '<')
			.replace(/&gt;/g, '>');
		  var OPTS = {
			'ENT_NOQUOTES': 0,
			'ENT_HTML_QUOTE_SINGLE': 1,
			'ENT_HTML_QUOTE_DOUBLE': 2,
			'ENT_COMPAT': 2,
			'ENT_QUOTES': 3,
			'ENT_IGNORE': 4
		  };
		  if (quote_style === 0) {
			noquotes = true;
		  }
		  if (typeof quote_style !== 'number') { // Allow for a single string or an array of string flags
			quote_style = [].concat(quote_style);
			for (i = 0; i < quote_style.length; i++) {
			  // Resolve string input to bitwise e.g. 'PATHINFO_EXTENSION' becomes 4
			  if (OPTS[quote_style[i]] === 0) {
				noquotes = true;
			  } else if (OPTS[quote_style[i]]) {
				optTemp = optTemp | OPTS[quote_style[i]];
			  }
			}
			quote_style = optTemp;
		  }
		  if (quote_style & OPTS.ENT_HTML_QUOTE_SINGLE) {
			string = string.replace(/&#0*39;/g, "'"); // PHP doesn't currently escape if more than one 0, but it should
			// string = string.replace(/&apos;|&#x0*27;/g, "'"); // This would also be useful here, but not a part of PHP
		  }
		  if (!noquotes) {
			string = string.replace(/&quot;/g, '"');
		  }
		  // Put this in last place to avoid escape being double-decoded
		  string = string.replace(/&amp;/g, '&');
		 
		  return string;
		}
      
		// Constructor
		Init();

		/**
		 * Get players
		 * @return {obj}
		 */
		this.GetPlayers = function () {
			return players;
		}

		//---------------------------------------------------------
		// Initialization
		//---------------------------------------------------------
		function Init() {
			// show loading popup while servers loading
			// Content list
			list = GetItem(gui.content);
			glist = GetItem(gui.main_page).CreateItem(IR.ITEM_GOOD_LIST, "ConList", list.X, list.Y, list.Width, list.Height);
			//glist.GetState(0).FillColor = 0xFFFFFFFF;
			glist.SelectMode = 2;
			glist.Adapter =
			{
				content: [{label: "Loading..", type: "Loading"}],
				total: 1,
				request: false,
				
				/**
				 * Get count
				 * @return {Int}
				 */
				GetCount: function () {
					return this.total;
				},
				
				/**
				 * Get item
				 * @param in_pos
				 * @return {item}
				 */
				GetItem: function (in_pos) {
					var l_item = GetItem("Sonos:AudioListTpl").Clone("" + in_pos);
					l_item.GetItem(1).Text = "Loading...";
					l_item.GetItem(6).Visible = false;
					l_item.GetItem(8).Visible = false;
					l_item.GetItem(9).Visible = false;
					l_item.GetItem(10).Visible = false;
					l_item.GetItem(5).Visible = false;
					l_item.GetItem(4).Visible = false;
					var l_data = this.content[in_pos];
					if (l_data) {
						l_item.GetItem(0).Hit = 2;
						l_item.GetItem(1).Text = l_data.label;
						switch (l_data.type) {
							case "Loading":
								break;
							case "mainFolder":
								l_item.GetItem(5).Visible = true;
								break;
							case "Folder":
								l_item.GetItem(5).Visible = true;
								l_item.GetItem(4).Opacity = 0;
								l_item.GetItem(4).Visible = true;
								break;
							case "Server":
								l_item.GetItem(8).Visible = true;
								l_item.GetItem(4).Opacity = 0;
								break;
							case "Radio":
								l_item.GetItem(9).Visible = true;
								l_item.GetItem(4).Visible = true;
								break;
							case "LineIn":
								l_item.GetItem(10).Visible = true;
								break;
							case "Element":
								l_item.GetItem(9).Visible = true;
								break;
							case "Subtitle":
								l_item.GetItem(3).Visible = false;
								break;
							case "Subelement":
								l_item.GetItem(4).Visible = false;
								break;
							case "Song":
								l_item.GetItem(6).Visible = true;
								l_item.GetItem(4).Visible = true;
								break;
						}
						IR.AddListener(IR.EVENT_ITEM_RELEASE, l_item.GetItem(4), function () {
							glist.SetSelected(l_item);
							if (folder == 'SQ:' || folder == 'FV:2' || /^SQ\:/.test(folder) /*|| folder.search("S:") >= 0*/
							)GetItem(gui.remove).Visible = glist.GetSelected().length > 0;
							if ((glist.Adapter.content[l_item.Name].type == "Song" || glist.Adapter.content[l_item.Name].type == "Folder" || glist.Adapter.content[l_item.Name].type == "Radio") && folder != 'FV:2') {
								if (/A\:.+/.test(glist.Adapter.content[l_item.Name]["@id"])) {
									var l_mas = glist.Adapter.content[l_item.Name]["@id"].match(/A\:.+/);
									if (/\//.test(l_mas))
										favorites.Visible = glist.GetSelected().length > 0;
								} else {
									favorites.Visible = glist.GetSelected().length > 0;
								}
							}
						});
						IR.AddListener(IR.EVENT_ITEM_RELEASE, l_item, function () {
							var l_content = glist.Adapter.content[l_item.Name];
							var l_type = l_content["upnp:class"];
							if (l_type == "none") {
								// do nothing
							} else if (l_type == "library") {
								server = players[0];
								UpdateContent("A:", "Music Library");
							} else if (l_type == "radio") {
								UpdateContent("/Browse.ashx", "Radio");
							} else if (l_type == "deezer") {
								UpdateDeezer(l_content.itemType, l_content.id, l_content.title); //"411385351"
							} else if (l_type == "link") {
								UpdateContent(l_content["res"], l_content["dc:title"]);
							} else if (l_type == "linein") {
								UpdateContent("AI:", "Line-In");
							} else if (l_type == "favorites") {
								server = players[0];
								UpdateContent("FV:2", "Favorites");
							} else if (l_type == "playlists") {
								server = players[0];
								UpdateContent("SQ:", "Playlists");
							} else if (l_type == "server") {
								// Server select
								server = servers[l_content["@id"]];
								UpdateContent(0, server.Description.root.device.friendlyName.toString());
							} else if (l_type.search("object.container") >= 0) {
								// Going in folder
								UpdateContent(l_content["@id"], l_content["dc:title"]);
							} else if (l_type == "audio") {
								/*"x-sonosapi-stream:s37062?sid=254&amp;flags=32"*/
								var s_id = l_content.res.indexOf("id=") + 3;
								var uri = "x-sonosapi-stream:" + l_content.res.substr(s_id) + "?sid=254&amp;flags=32";
								PlayBack(l_content["dc:title"].toString().replace("&", "&amp;"), uri, 1, l_content["type"]=="Song");
								// block while buffering
								//module.GetPopup(gui.main_page).ShowPopup(gui.loading);
							} else if (/^x\-rincon\-stream/.test(l_content.res)) {
                     if(l_content.res != _uri){                 
   							group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", {
									InstanceID: 0,
									CurrentURI: l_content.res,
									CurrentURIMetaData: ""
								});
                        _uri = l_content.res;    
                     }							
							} else {
								// add to queue
								group.parent.InvokeAction("AddURIToQueue", "urn:schemas-upnp-org:service:AVTransport:1", {
									InstanceID: 0,
									EnqueuedURI: l_content.res,
									EnqueuedURIMetaData: "",
									DesiredFirstTrackNumberEnqueued: 0,
									EnqueueAsNext: true
								});

								// Playback							
								var _idd = gplaylist.Adapter.total;
								debug(_idd);
								var uri = "x-rincon-queue:" + group.parent.Description.root.device.UDN.toString().substr(5) + "#0";
                        if(uri != _uri){                 
      							group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", {
   									InstanceID: 0,
   									CurrentURI: uri,
   									CurrentURIMetaData: ""
   								});
                           _uri = uri;    
                        }
								group.parent.InvokeAction("Seek", "urn:schemas-upnp-org:service:AVTransport:1", {
									InstanceID: 0,
									Unit: "TRACK_NR",
									Target: ++_idd
								});
								if (play.Value == 0)
									group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {
										InstanceID: 0,
										Speed: 1
									});
							}
						});
					} else if (!this.request) {
						IR.Log("zapros left")
						IR.Log("request left " + this.request)
						this.request = true;
						if (server)
							server.InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1",
								{
									ObjectID: folder,
									BrowseFlag: "BrowseDirectChildren",
									Filter: "dc:title,res",
									StartingIndex: this.content.length,
									RequestedCount: 99999,
									SortCriteria: ""
								}, function (in_text) { 
									IR.Log("text return")
									var l_i, l_xml, l_response, l_items, l_item, l_id, l_title;
									var l_self = glist.Adapter;
									// Create XML from text
									IR.Log("xml left pre")
									l_xml = new XML(htmlspecialchars_decode(in_text));
									IR.Log("xml left post")
                           try{
                              if(l_xml["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]["SOAP-ENV:Fault"]["faultstring"].toString()=="UPnPError"){
                                 l_self.request = false;
                                 UpdateContent(-1, "Music Sources"); 
                                 IR.ShowPopup(gui.warning_popup);
   						            GetItem(gui.warning_msg).Text = l_xml["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]["SOAP-ENV:Fault"]["detail"]["u:UPnPError"]["u:errorDescription"].toString() || "ERROR!"; 
                                 return;                           
                              }
                           }catch(e){ 
										IR.Log(e)
                           }
									if (l_xml["s:Envelope"] != undefined)
										l_response = l_xml["s:Envelope"]["s:Body"]["u:BrowseResponse"];
									else
										l_response = l_xml["SOAP-ENV:Envelope"]["SOAP-ENV:Body"]["m:BrowseResponse"];
									try {
										l_self.total = l_response.TotalMatches;
										IR.Log(l_response.TotalMatches)
										// Folders
										l_id = l_self.content.length;
										l_items = l_response["Result"]["DIDL-Lite"]["container"];
										if (l_items != undefined) {
											l_i = 0;
											while (l_item = l_items[l_i++]) {
												var l_artist = "";
												l_title = l_item["dc:title"].toString();
												// Data
												l_self.content[l_id++] = {
													"@id": l_item["@id"].toString(),
													"upnp:class": l_item["upnp:class"].toString(),
													"dc:title": l_title,
													type: "Folder",
													"label": l_title,
													"res": l_item.res ? l_item.res.toString() : "",
												};
											}
										}
										// Songs
										l_items = l_response["Result"]["DIDL-Lite"]["item"];
										if (l_items != undefined) {
											l_i = 0;
											while (l_item = l_items[l_i++]) {
												l_title = l_item["dc:title"].toString();
												var upnp_class = l_item["upnp:class"].toString();
												var _upnp_class = "audio";
												var _type = "Song";
												var item_id = l_item["@id"].toString();
												var fv_id;
												if(/^FV\:.+/.test(item_id))
													fv_id = item_id;
												try {
													_upnp_class = l_item["r:resMD"]["DIDL-Lite"]["item"]["upnp:class"].toString()
													if (_upnp_class.indexOf("object.container") != -1) {
														_type = "Folder";
														item_id = l_item["r:resMD"]["DIDL-Lite"]["item"]["@id"].toString();
														upnp_class = _upnp_class;
													} else if (_upnp_class == "object.item.audioItem.audioBroadcast") {
														_type = "Radio";
														var _res = l_item["res"].toString().match(/x-sonosapi-stream\:(.+)\?sid/);
														upnp_class = "audio";
														if(_res.length > 1){
															l_item.res = "id=" + _res[1]
														}else{
															l_item.res = "id=" + l_item["res"].toString().match(/\?id=(.+)/)[1]
														}
														
													}
												} catch (e) {
												}
												// Data
												if(fv_id){
													l_self.content[l_id++] = {
														"@id": item_id,
														"F_id": fv_id,
														"upnp:class": upnp_class,
														"dc:title": l_title,
														type: _type,
														"label": l_title,
														"res": l_item.res ? l_item.res.toString() : "",
													};
												}else{
													l_self.content[l_id++] = {
														"@id": item_id,
														"upnp:class": upnp_class,
														"dc:title": l_title,
														type: _type,
														"label": l_title,
														"res": l_item.res ? l_item.res.toString() : "",
													};
												}
											}
										}
										l_self.request = false;
										glist.Update();
										_content = glist.Adapter.content;
										filter.Text = "";
                              pren = true;
                              back.Visible = true;
									} catch (e) {
										IR.Log(e)
									}
									//self.request = false;
									//glist.Update();
									/////////////////
								});

					}
					return l_item;
				},
				
				/**
				 * Set selected
				 * @param in_item
				 * @param in_state
				 */
				SetSelected: function (in_item, in_state) {
					in_item.GetState(0).FillColor = in_state ? gui.contentCol1 : gui.contentCol10;
					in_item.GetItem(4).Value = in_state;
				}
			};

			// Current folder
			name = GetItem(gui.folder);

			// Filter of list
			IR.AddListener(IR.EVENT_ITEM_CHANGE, GetItem(gui.filter), function () {
				var l_cont = [];
				for (var i = 0; i < _content.length; i++) {
					if (new RegExp(filter.Text, 'i').test(_content[i]["label"]))
						l_cont.push(_content[i]);
				}
				glist.Adapter.content = l_cont;
				glist.Adapter.total = l_cont.length;
				glist.Update();
			});
         
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.stopsearch), function(){
            glist.Adapter.total = _content.length;
            glist.Adapter.content = _content;
            glist.Update();
         })

			// Back button
			back = GetItem(gui.back);
			IR.AddListener(IR.EVENT_ITEM_PRESS, back, function () {
				if (history.length > 1) {
					history.pop();
					var l_prev = history.pop();
               glist.Adapter.request = false;
					UpdateContent(l_prev.id, l_prev.name);
				}
			});

			// Current zone
			zone = GetItem(gui.zone);

			// Group list
			grouplist = GetItem(gui.groupList);
			IR.AddListener(IR.EVENT_ITEM_SELECT, grouplist, function (in_item, in_subItem) {
				// Select group
				SelectGroup(in_item);
				// Select group members
				if (in_subItem == 3) {
					UpdateMemberList();
					var l_prev = history.pop();
					if (l_prev.type == 'Content')
						UpdateContent(l_prev.id, l_prev.name);
					else
						UpdateDeezer(l_prev.type, l_prev.id, l_prev.name);
					UpdatePlaylist();
				}
			});

			// Volume group list
			volume_group_list = GetItem(gui.volume_group_list);
			IR.AddListener(IR.EVENT_ITEM_SELECT, volume_group_list, function (in_item, in_subItem) {
				switch (in_subItem) {
					case 1: // mute
					{
						players[in_item].InvokeAction("SetMute", "urn:schemas-upnp-org:service:RenderingControl:1", {
							InstanceID: 0,
							Channel: "Master",
							DesiredMute: players[in_item].mute_val == 0 ? 1 : 0
						});
						break;
					}
					case 3: //minus
						players[in_item].InvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {
							InstanceID: 0,
							Channel: "Master",
							Adjustment: -5
						});
						break;
					case 4: // plus
						players[in_item].InvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {
							InstanceID: 0,
							Channel: "Master",
							Adjustment: 5
						});
						break;
				}
			});

			// Group members list
			memberlist = GetItem(gui.memberList);
			IR.AddListener(IR.EVENT_ITEM_SELECT, memberlist, function (in_item) {
				memberselect[in_item] ^= 1;
				try {
					memberlist.CreateItem(in_item, 3, {
						Value: memberselect[in_item] & 1
					});
				} catch (e) {

				}
			});

			// Regroup button
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.memberDone), function () {
				Regroup();
			});

			// Playlist	
			playlist = GetItem(gui.playlist);
			gplaylist = GetItem(gui.main_page).CreateItem(IR.ITEM_GOOD_LIST, "GPlaylist", playlist.X, playlist.Y, playlist.Width, playlist.Height);
			gplaylist.SelectMode = 2;         
			gplaylist.Adapter =
			{
				content: [{title: "Loading...", artist: ""}],
				total: 1,
				request: false,

				/**
				 * Get count
				 * @return {Int}
				 */
				GetCount: function () {
					var l_text = GetItem(gui.count).Text;
					if (/^\d+ of \d+/.test(l_text)) {
						GetItem(gui.count).Text = l_text.substring(0, l_text.indexOf(" of ") + 4) + this.total;
					}
					else
						GetItem(gui.count).Text = "Loading..";         
					return this.total;
				},
				/**
				 * Get item
				 * @param in_pos
				 * @return {item}
				 */
				GetItem: function (in_pos) {
					var l_item = GetItem("Sonos:AudioListTpl 1").Clone("" + in_pos);
					l_item.GetItem(1).Text = "Loading...";
					var l_data = this.content[in_pos];
					if (l_data) {
						l_item.GetItem(0).Hit = 2;
						l_item.GetItem(1).Text = l_data.title;
						l_item.GetItem(2).Text = l_data.artist;
						if (l_data.image) {
							var l_url = "http://" + group.parent.Host + ":" + group.parent.Port + l_data.image;
							l_item.GetItem(3).GetState(0).Image = l_url;
						}

						IR.AddListener(IR.EVENT_ITEM_RELEASE, l_item.GetItem(4), function () {
							gplaylist.SetSelected(l_item);
							ToggleDeleteButton(gplaylist.GetSelected().length > 0)
						});

						IR.AddListener(IR.EVENT_ITEM_RELEASE, l_item, function () {
							// Playback
							var uri = "x-rincon-queue:" + group.parent.Description.root.device.UDN.toString().substr(5) + "#0";  
                     if(uri != _uri){                 
   							group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1",
   								{InstanceID: 0, CurrentURI: uri, CurrentURIMetaData: ""});
                        _uri = uri;    
                     }
							group.parent.InvokeAction("Seek", "urn:schemas-upnp-org:service:AVTransport:1",
								{InstanceID: 0, Unit: "TRACK_NR", Target: Number(l_item.Name) + 1});
							if (play.Value == 0)
								group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {
									InstanceID: 0,
									Speed: 1
								});
						});
					} else if (!this.request) {
						IR.Log("zapros right")
						IR.Log("request right " + this.request)
						this.request = true;
						group.parent.InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1",
							{
								ObjectID: "Q:0",
								BrowseFlag: "BrowseDirectChildren",
								Filter: "dc:title,dc:creator",
								StartingIndex: 0,
								RequestedCount: 100,
								SortCriteria: ""
							}, function (in_text) {
								IR.Log("return right")
								var l_self = gplaylist.Adapter;
								var l_xml = new XML(in_text);
								IR.Log("post xml")
								var l_response = l_xml["s:Envelope"]["s:Body"]["u:BrowseResponse"];
								var l_items = l_response["Result"]["DIDL-Lite"]["item"];
								var id = l_self.content.length;
                        if(id == 1){
                           id = 0;
                        }
                        l_self.total = l_response.TotalMatches;
								IR.Log("l_response.TotalMatches " + l_response.TotalMatches)
								if (l_items != undefined) {
									var i = 0;
									while (l_item = l_items[i++]) {
										l_self.content[id++] = {
											artist: (l_item["dc:creator"] ? l_item["dc:creator"].toString() : ""),
											title: l_item["dc:title"].toString(),
											image: l_item["upnp:albumArtURI"].toString()
										};
									}
								}

								l_self.request = false;
								gplaylist.Update();
                        gplaylist.ClearSelected();
								if(current <= gplaylist.Adapter.total){
									GetItem(gui.count).Text = current + " of " + gplaylist.Adapter.total;
								}else{	if(gplaylist.Adapter.total == 0) GetItem(gui.count).Text = "0 of 0 "}
							});
					}
					return l_item;
				},

				/**
				 * Set selected
				 * @param in_item
				 * @param in_state
				 */
				SetSelected: function (in_item, in_state) {
					in_item.GetState(0).FillColor = in_state ? gui.contentCol1 : gui.contentCol10;
					in_item.GetItem(4).Value = in_state;
				}
			};
			ToggleDeleteButton(false);

			// Add button
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.add), AddToPlaylist);

			// Replace button
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.replace), function () {
				group.parent.InvokeAction("RemoveAllTracksFromQueue", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0
				});
				AddToPlaylist();
				Play(1);
			});

			// Button to save the playlist
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.saveOk), function () {
				if (gplaylist.Adapter.total > 0) {
					group.parent.InvokeAction("SaveQueue", "urn:schemas-upnp-org:service:AVTransport:1", {
						InstanceID: 0,
						Title: GetItem(gui.saveName).Text,
						ObjectID: ""
					});
					IR.GetPopup(gui.main_page).HidePopup(gui.save);
				} else {
					IR.SetTimeout(500, function () {
						//IR.ShowPopup(gui.mask);
						IR.ShowPopup(gui.warning_popup);
						GetItem(gui.warning_msg).Text = "Add Song to PlayList!";
					});
				}
			});
			GetItem(gui.saveName).Text = "My Playlist";

			// Button to add to favorites
			favorites = GetItem(gui.favorites);
			IR.AddListener(IR.EVENT_ITEM_PRESS, favorites, AddToFavorites);

			// Button to remove from favorites
			remove = GetItem(gui.remove);
			IR.AddListener(IR.EVENT_ITEM_PRESS, remove, DeleteObjects);

			// Clear button
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.clear), function () {
				group.parent.InvokeAction("RemoveAllTracksFromQueue", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0
				});
				artist.Text = "";
				track.Text = "";
				album.Text = "";
				GetItem(gui.count).Text = "0 of 0";
				art.GetState(0).Image = "pic 640x528.png";
			});

			// Delete button
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.deleteb), function () {
				var _select = gplaylist.GetSelected();
				gplaylist.ClearSelected();
				for (var i = _select.length - 1; i >= 0; --i)
					group.parent.InvokeAction("RemoveTrackFromQueue", "urn:schemas-upnp-org:service:AVTransport:1", {
						InstanceID: 0,
						ObjectID: "Q:0/" + (_select[i] + 1),
						UpdateID: 0
					});
			});

			// Start playback button
			play = GetItem(gui.play);
			
			/**
			 * Play
			 * @param in_play
			 */
			function Play(in_play) {
				if (in_play == 0)
					group.parent.InvokeAction("Pause", "urn:schemas-upnp-org:service:AVTransport:1", {
						InstanceID: 0
					});
				else
					group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {
						InstanceID: 0,
						Speed: 1
					});
			}

			/**
			 * Next
			 */
			function Next() {
				group.parent.InvokeAction("Next", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0
				});
			}

			/**
			 * Prev
			 */
			function Prev() {
				group.parent.InvokeAction("Previous", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0
				});
			}

			IR.AddListener(IR.EVENT_ITEM_PRESS, play, function () {
				Play(play.Value)
			});

			// Next track button
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.next), Next);

			// Previous track button
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.previous), Prev);

			// Track info
			track = GetItem(gui.track);
			artist = GetItem(gui.artist);
			album = GetItem(gui.album);
			art = GetItem(gui.cover);

			// Volume level
			percent = GetItem(gui.percent);
			volume = GetItem(gui.volume);
			
			/**
			 * Volume
			 * @param in_volume
			 */
			function Volume(in_volume) {
				var global_vol = in_volume.Value; // new global volume value
				percent.Text = global_vol + '%';

				// only one player in group
				if (group.members.length == 0) {
					group.parent.InvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {
						InstanceID: 0,
						Channel: "Master",
						DesiredVolume: global_vol
					});
				} else {
					// calc new volume for each player
					var mean = CalcGroupVolume(group); // calc old global volume (TODO - можно хранить отдельно)
					// increment of global volume
					var inc_mean = (mean) ? (global_vol / mean) : global_vol;
					// if one of players get maximum other must increments faster
					var aver = CalcAverage(group, inc_mean);
					// calc new value for group parent
					var nvol = CalcNewVol(group.parent.player_volume, inc_mean, aver);
					group.parent.InvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {
						InstanceID: 0,
						Channel: "Master",
						DesiredVolume: nvol
					});
					// and for members
					for (var i = 0; i < group.members.length; ++i) {
						nvol = CalcNewVol(group.members[i].player_volume, inc_mean, aver);
						group.members[i].InvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {
							InstanceID: 0,
							Channel: "Master",
							DesiredVolume: nvol
						});
					}
				}
				//GroupInvokeAction("SetVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {InstanceID: 0, Channel: "Master", DesiredVolume: volume.Value});
			}

			IR.AddListener(IR.EVENT_ITEM_RELEASE, volume, function () {
				Volume(volume)
			});
			
			/**
			 * change volume
			 * @param in_adj
			 */
			function changeVolume(in_adj) {
				GroupInvokeAction("SetRelativeVolume", "urn:schemas-upnp-org:service:RenderingControl:1", {
					InstanceID: 0,
					Channel: "Master",
					Adjustment: in_adj
				});
			}

			/**
			 * Mute
			 * @param in_mute
			 */
			function Mute(in_mute) {
				GroupInvokeAction("SetMute", "urn:schemas-upnp-org:service:RenderingControl:1", {
					InstanceID: 0,
					Channel: "Master",
					DesiredMute: in_mute.Value
				});
			}

			/**
			 * Shuffle
			 * @param in_shuffle
			 */
			function Shuffle(in_shuffle) {
				var l_mode = (in_shuffle.Value << 1) | repeat.Value;
				group.parent.InvokeAction("SetPlayMode", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0,
					NewPlayMode: modes[l_mode]
				});
			}

			/**
			 * Repeat
			 * @param in_repeat
			 */
			function Repeat(in_repeat) {
				var l_mode = (shuffle.Value << 1) | in_repeat.Value;
				group.parent.InvokeAction("SetPlayMode", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0,
					NewPlayMode: modes[l_mode]
				});
			}

			/**
			 * timeline Unl
			 * @param in_timeline
			 */
			function timelineUnl(in_timeline) {
				in_timeline.lock = false;
				position = in_timeline.Value / 100 * duration;
				var l_text = "" + Math.floor(position / 3600) + ":" + Math.floor(position % 3600 / 60) + ":" + Math.floor(position % 60);
				group.parent.InvokeAction("Seek", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0,
					Unit: "REL_TIME",
					Target: l_text
				});
			}


			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.plus), function () {
				changeVolume(5)
			})
			IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(gui.minus), function () {
				changeVolume(-5)
			})

			mute = GetItem(gui.mute);
			IR.AddListener(IR.EVENT_ITEM_PRESS, mute, function () {
				Mute(mute)
			});

			// Playback modes
			shuffle = GetItem(gui.shuffle);
			IR.AddListener(IR.EVENT_ITEM_PRESS, shuffle, function () {
				Shuffle(shuffle)
			});

			repeat = GetItem(gui.repeat);
			IR.AddListener(IR.EVENT_ITEM_PRESS, repeat, function () {
				Repeat(repeat)
			});

			// Playback position
			timeleft = GetItem(gui.timeleft);
			timeline = GetItem(gui.timeline);
			timepast = GetItem(gui.timepast);
			IR.AddListener(IR.EVENT_ITEM_PRESS, timeline, function () {
				timeline.lock = true;
			});

			IR.AddListener(IR.EVENT_ITEM_RELEASE, timeline, function () {
				timelineUnl(timeline)
			});

			// Try to connect
			IR.SetInterval(30000, function () {
				for (var i = 0; i < disconnected.length; ++i)
					disconnected[i].Connect();
				disconnected.length = 0;
			});

			// Create UPNP device
			upnp = IR.CreateDevice(IR.DEVICE_UPNP_CONTROL, "UpnpControl");
			upnp.Connect();

			// Create browser of radios
			radio = IR.CreateDevice(IR.DEVICE_CUSTOM_HTTP_TCP, "Tunein", "opml.radiotime.com", 80);
			IR.AddListener(IR.EVENT_RECEIVE_TEXT, radio, UpdateRadioCallback);

			// Create browser of radios
			//deezer = IR.CreateDevice(IR.DEVICE_CUSTOM_TCP, "Deezer", "deezer.ws.sonos.com", 80);
			//IR.AddListener(IR.EVENT_RECEIVE_TEXT, deezer, UpdateDeezerCallback);

			// Found device listener
			IR.AddListener(IR.EVENT_DEVICE_FOUND, 0, FoundDevice);

			// Every cycle function
			IR.AddListener(IR.EVENT_WORK, 0, Work);

			// Load players on waking
			//IR.AddListener(IR.EVENT_APP_ENTER_FOREGROUND, 0, LoadPlayers);

			// Load players on start
			LoadPlayers();
		}

		/**
		 * Found device
		 * @param in_uuid
		 * @param in_url
		 */
		function FoundDevice(in_uuid, in_url) {
			// Create device
			if (IR.GetDevice(in_uuid))
				return;
			var l_device = IR.CreateDevice(IR.DEVICE_UPNP_DEVICE, in_uuid);

			// Set device parameters
			var host = in_url.indexOf("http://");
			if (host >= 0) {
				host += 7;
				var port = in_url.indexOf(":", host);
				if (port > 0) {
					port += 1;
					var path = in_url.indexOf("/", port);
					if (path > 0) {
						l_device.SetParameters({
							Host: in_url.substr(host, port - host - 1),
							Port: in_url.substr(port, path - port),
							DescriptionUrl: in_url.substr(path)
						});
						

						// Event: device connected
						IR.AddListener(IR.EVENT_ONLINE, l_device, function () {
							var xml = this.Description.root.device;
							var type = xml.deviceType.toString();

							// If server
							if (type.indexOf("urn:schemas-upnp-org:device:MediaServer") >= 0) {
								servers.push(this);
								if (folder == -1) {
									history.length = 0;
									UpdateContent(folder, "Music Sources");
								}
							}
							// If player
							if (type.indexOf("urn:schemas-upnp-org:device:ZonePlayer") >= 0 && xml.modelNumber.toString().indexOf("ZB") < 0) {
								players.push(this);
								SavePlayers();

								// Subscribe to device events
								IR.AddListener(IR.EVENT_RECEIVE_EVENT, this, ReceiveEvent, this);
								Subscribe(this);
								// Update groups list
								UpdateGroups();
								// Update content list
								if (folder == -1) {
									history.length = 0;
									UpdateContent(folder, "Music Sources");
								}
							}
						}, l_device);
l_device.Connect();
						// Event: device disconnected
						IR.AddListener(IR.EVENT_OFFLINE, l_device, function () {
							var l_i;
							// Remove from servers list
							for (l_i = 0; l_i < servers.length; ++l_i)
								if (servers[l_i] == this) {
									servers.splice(l_i, 1);
									if (folder == -1) {
										history.length = 0;
										UpdateContent(folder, "Music Sources");
									}
									break;
								}

							// Remove from players list
							for (l_i = 0; l_i < players.length; ++l_i)
								if (players[l_i] == this) {
									players.splice(l_i, 1);
									// Update groups list
									UpdateGroups();
									if (folder == -1) {
										up_icon = GetItem(gui.up_icon);
										history.length = 0;
										UpdateContent(folder, "Music Sources");
									}
									break;
								}

							// Add to disconnected
							disconnected.push(this);

						}, l_device);
					}
				}
			}
		}

		/**
		 * Update content
		 * @param in_nfolder
		 * @param in_nname
		 */
		function UpdateContent(in_nfolder, in_nname) {
			GetItem(gui.remove).Visible = false;
			GetItem(gui.favorites).Visible = false;
			glist.ClearSelected();
			var l_i, l_xml, l_cont, l_id;
			name.Text = in_nname;
			folder = in_nfolder;
			history.push({id: folder, name: in_nname});
			if (folder == 'FV:2') favorites.Visible = false;
         l_cont = glist.Adapter.content;
			l_cont.length = 0;
			if (folder == -1) {
				l_id = 0;
            pren = true;
				back.Visible = false;
				// Sonos library
				if (players.length) {
					l_cont[l_id++] = {"@id": 0, label: "Music Library", type: "mainFolder", "upnp:class": "library"};
				}
				//radio
				l_cont[l_id++] = {"@id": 0, label: "Radio", type: "mainFolder", "upnp:class": "radio"};
				//LineIn
				l_cont[l_id++] = {"@id": 0, label: "Line-In", type: "mainFolder", "upnp:class": "linein"};
				// Favorites
				l_cont[l_id++] = {"@id": 0, label: "Favorites", type: "mainFolder", "upnp:class": "favorites"};
				// Playlists
				l_cont[l_id++] = {"@id": 0, label: "Sonos Playlists", type: "mainFolder", "upnp:class": "playlists"};
				// Media servers
				for (l_i = 0; l_i < servers.length; ++l_i) {
					l_xml = servers[l_i].Description.root.device;
					l_cont[l_id++] = {
						"@id": l_i,
						label: l_xml.friendlyName.toString(),
						type: "Server",
						"upnp:class": "server"
					};
				}

				glist.Adapter.total = l_id;
			} else {
            HideBack();
				if (folder.toString().indexOf("/") == 0) {
					glist.Adapter.total = 1;
					radio.Connect();
					radio.Send(['GET,' + folder + ',']);
				} else if (folder == "AI:") {
					var length = 0;
					glist.Adapter.total = 1;
					for (var i = 0; i < players.length; ++i) {
						// LineIn devices request
						players[i].InvokeAction("Browse", "urn:schemas-upnp-org:service:ContentDirectory:1", {
								ObjectID: folder,
								BrowseFlag: "BrowseDirectChildren",
								Filter: "",
								StartingIndex: 0,
								//RequestedCount: 10,
								SortCriteria: ""
							},
							function (index) {
								return function (in_text) {
									try {
										var l_xml = new XML(in_text);
										var l_items = l_xml["s:Envelope"]["s:Body"]["u:BrowseResponse"]["Result"]["DIDL-Lite"]["item"];
										l_id = l_cont.length;
										var j = 0;
										while (item = l_items[j++]) {
											var title = item["dc:title"].toString() + ": " + players[index].Description.root.device.roomName.toString();
											l_cont[l_id++] = {
												"@id": item["@id"].toString(),
												"upnp:class": item["upnp:class"].toString(),
												"dc:title": title,
												type: "LineIn",
												"label": title,
												"res": item.res ? item.res.toString() : "",
											};
											length++;
										}
										glist.Adapter.total = length;
										glist.Update();
										glist.Adapter.request = false;
                              pren = true;
                              back.Visible = true;
									} catch (error) {
									}
								}
							}
							(i));
					}
				} else {
					//cont[0] = {label: "Loading..."};
					glist.Adapter.total = 1;
				}
			}
			IR.SetTimeout(1, function () {
				//glist.Adapter.total = length;
				glist.Update();
				_content = glist.Adapter.content;
				filter.Text = "";
			});
		}

		/**
		 * Update radio callback
		 * @param in_text
		 */
		function UpdateRadioCallback(in_text) {
			if (/\<\?xml version\=\"1\.0\" encoding\=\"UTF\-8\"\?\>/.test(in_text)) {
				radiocallback = in_text;
				if (in_text.indexOf("</opml>")==-1) {
					return;
				}
			} else {
				if (in_text.indexOf("</opml>")!=-1) {
					radiocallback += in_text;
				} else {
					radiocallback += in_text;
					return;
				}
			}
			var l_self = glist.Adapter;
			try {
				var l_i,
					l_j,
					l_xml,
					l_items,
					l_item,
					l_title,
					l_type,
					l_sitems;
				l_xml = new XML(radiocallback);
				radiocallback = undefined;
				l_items = l_xml.opml.body.outline;
				var total = 1;
				id = l_self.content.length;
				l_i = 0;
				while (l_item = l_items[l_i++]) {
					l_title = l_item["@text"].toString();
					/*self.content[id++] = {
					 "@id":         i, 
					 "upnp:class":  "radio", 
					 "dc:title":    title,
					 type: 		   "mainFolder",
					 "label":       title,
					 "res":         item.res ? item.res.toString() : "",
					 };*///сомнительные элементы
					if (l_item["@type"]) {
						l_type = l_item["@type"].toString();
						if (l_type == "link") {
							// Folder
							l_self.content[id++] = {
								"@id": l_i,
								"upnp:class": l_type,
								"dc:title": l_title,
								type: "mainFolder",
								"label": l_title,
								"res": l_item["@URL"].toString().substr(25)
							};
						} else {
							// Stream
							l_self.content[id++] = {
								"@id": l_i,
								"upnp:class": "audio",
								"dc:title": l_title,
								type: "Radio",
								"label": l_title,
								"res": "x-rincon-mp3radio" + l_item["@URL"].toString().substr(4).replace("&", "&amp;")
							};
						}

					} else {
						// Subtitle
						l_self.content[id++] = {
							"@id": l_i,
							"upnp:class": "none",
							"dc:title": l_title,
							type: "Subtitle",
							"label": l_title
						};

						// Subelement
						l_sitems = l_item.outline;
						l_j = 0;
						while (l_item = l_sitems[l_j++]) {
							l_title = l_item["@text"].toString();
							/*
							 self.content[id++] = {
							 "@id":         i, 
							 "upnp:class":  "none", 
							 "dc:title":    title,
							 type: 		   "Subelement",
							 "label":       title
							 };*///еще сомнительные элементы
							if (l_type == "link") {
								// Folder
								l_self.content[id++] = {
									"@id": l_i,
									"upnp:class": l_type,
									"dc:title": l_title,
									type: "mainFolder",
									"label": l_title,
									"res": l_item["@URL"].toString().substr(25)
								};
							} else {
								// Stream
								l_self.content[id++] = {
									"@id": l_i,
									"upnp:class": "audio",
									"dc:title": l_title,
									type: "Radio",
									"label": l_title,
									"res": "x-rincon-mp3radio" + l_item["@URL"].toString().substr(4).replace("&", "&amp;")
								};
							}
						}
					}
				}
				l_self.request = false;
				try {
					if (l_xml.opml.body.outline["@key"] == "stations") {
						try {
							while (true)
								l_xml.opml.body.outline.outline[total++].toXMLString()
						} catch (e) {
						}
					} else {
						try {
							while (true)
								l_xml.opml.body.outline[total++].toXMLString()
						} catch (e) {
						}
					}
				} catch (e) {
				}
				l_self.total = --total;
				glist.Update();
				_content = glist.Adapter.content;
				filter.Text = "";
            pren = true;
            back.Visible = true;
			} catch (error) {
				// Hide popup if catch exception
				IR.Log("UpdateRadioCallback Exception!");
				IR.Log(error);
			}
		}

		/**
		 * Update deezer callback
		 * @param in_text
		 */
		function UpdateDeezerCallback(in_text) {
			try {
				var l_item,
					l_count,
					l_response;
				var l_packet_start = in_text.indexOf('<s:Envelope');
				//debug('packet_start ' + packet_start);
				in_text = in_text.substring(l_packet_start);

				var l_xml = new XML(deezer_buffer + in_text);

				l_response = l_xml["s:Envelope"]["s:Body"]["ns:getMetadataResponse"];

				if (l_response)
					l_response = l_response['ns:getMetadataResult'];

				l_count = l_response['ns:count'];

				if (l_count) {
					l_item = l_response['ns:mediaCollection'];
					list.Clear();
				}

				for (var id = 0; id < l_count; id++) {
					content[id] = {
						'upnp:class': 'deezer',
						'id': l_item[id]['ns:id'].toString(),
						'itemType': l_item[id]['ns:itemType'].toString(),
						'title': l_item[id]['ns:title'].toString(),
					};
					try {
						list.CreateItem(id, 2, {
							Text: content[id].title
						});
						list.CreateItem(id, 5, {
							Visible: false,
							Enable: false
						});
					} catch (e) {

					}
					var l_art = l_item[id]['ns:albumArtURI'];

					if (l_art) {
						//debug(art.toString());
						try {
							list.CreateItem(id, 4, {
								Image: l_art.toString()
							});
						} catch (e) {

						}
					} else
						try {
							list.CreateItem(id, 7, {
								Visible: false
							});
						} catch (e) {

						}
				}
				deezer_buffer = '';
			} catch (error) {
				list.Clear();
				IR.Log("UpdateDeezerCallback Exception! " + error);
				deezer_buffer += in_text;
			}
		}

		/**
		 * Update deezer
		 * @param in_itemType
		 * @param in_id
		 * @param in_title
		 */
		function UpdateDeezer(in_itemType, in_id, in_title) {
			try {
				switch (in_itemType) {
					case undefined:
					case 'favorites':
					case 'container':
					case 'genre':
					case 'artist':
						var l_request = FormInvokeAction('POST', '/services/smapi', 'deezer.ws.sonos.com', 'getMetadata', in_id);
						deezer.Send(l_request);
						history.push({
							type: in_itemType,
							id: in_id,
							name: in_title
						});
						name.Text = in_title;
						break;
					case 'program':
						var uri = 'x-sonosapi-radio:' + in_id.replace(/:/g, '%3a') + '?sid=2&amp;flags=76';
						PlayBack(in_title, uri, 1);
						break;
					default:
						debug('UpdateDeezer default ' + in_itemType);
						break;
				}

			} catch (e) {
			}
		}

		/**
		 * Update playlist
		 */
		function UpdatePlaylist() {
			gplaylist.Adapter.content.length = 0;
			gplaylist.Adapter.total = 1;
			gplaylist.Update();
         gplaylist.ClearSelected();
		}

		/**
		 * Update groups
		 */
		function UpdateGroups() {
			var l_info = [];
			var l_num = players.length;
			grouplist.Clear();
			volume_group_list.Clear();

			for (var i = 0; i < l_num; ++i) {
				group_created = false;
				// Receiving meta data
				players[i].InvokeAction("GetMediaInfo", "urn:schemas-upnp-org:service:AVTransport:1", {
					InstanceID: 0
				}, function (index) {
					return function (text) {
						var l_xml = new XML(text);
						l_info[index] = l_xml["s:Envelope"]["s:Body"]["u:GetMediaInfoResponse"]["CurrentURI"].toString();

						// If received all data, create a groups
						if (--l_num == 0) {
							// Create groups
							group = undefined;
							zone.Text = "";
							groups.length = 0;

							for (i = 0; i < l_info.length; ++i) {
								if (!l_info[i] || l_info[i].indexOf("x-rincon:") < 0) {
									players[i].group = undefined;

									var ngroup = {
										parent: players[i],
										members: [],
										name: players[i].Description.root.device.roomName.toString(),
										uri: "x-rincon:" + players[i].Description.root.device.UDN.toString().substr(5)
									};

									groups.push(ngroup);
									// Add members
									for (var j = 0; j < l_info.length; ++j) {
										if (l_info[j] == ngroup.uri) {
											ngroup.members.push(players[j]);
											ngroup.name += ", " + players[j].Description.root.device.roomName;
											players[j].group = ngroup;
										}
										try {
											volume_group_list.CreateItem(j, 2, {
												Text: players[j].Description.root.device.roomName.toString()
											});
										} catch (e) {

										}
									}
								}
							}
							// Update list
							grouplist.Clear();
							for (i = 0; i < groups.length; ++i) {
								try {
									grouplist.CreateItem(i, 4, {
										Text: groups[i].name
									});
								} catch (e) {

								}
							}
							group_created = true;

							for (i in players) {
								if(players.hasOwnProperty(i)){
									UnSubscribe(players[i]);
									Subscribe(players[i]);
								}
							}

							// Select first group default
							SelectGroup(selected_zone);
						}
					}
				}
				(i));
			}
		}

		/**
		 * Update member list
		 */
		function UpdateMemberList() {
			memberlist.Clear();
			memberselect.length = 0;
			for (var i = 0; i < players.length; ++i) {
				try {
					memberlist.CreateItem(i, 1, {
						Text: players[i].Description.root.device.roomName.toString()
					});
				} catch (e) {

				}
				var l_check = (players[i] == group.parent);
				for (var j = 0; j < group.members.length && !l_check; ++j)
					l_check = (players[i] == group.members[j]);
				if (l_check) {
					try {
						memberlist.CreateItem(i, 3, {
							Value: 1
						});
					} catch (e) {

					}
					memberselect[i] = 3;
				}
			}
		}

		/**
		 * Regroup
		 */
		function Regroup() {
			var l_parentUri = "x-rincon:" + group.parent.Description.root.device.UDN.toString().substr(5);
			for (var i = 0; i < players.length; ++i) {
				var l_old = memberselect[i] >> 1;
				if (memberselect[i] & 1) {
					// Add to group
					if (!l_old) {
						ToggleOpenVolumeGroup(true);
                  if(l_parentUri != _uri){                 
							players[i].InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", {
   							InstanceID: 0,
   							CurrentURI: l_parentUri,
   							CurrentURIMetaData: ""
   						});
                     _uri = l_parentUri;    
                  }
					}
				} else if (l_old) {
					ToggleOpenVolumeGroup(false);
					// Remove from group
					players[i].InvokeAction("BecomeCoordinatorOfStandaloneGroup", "urn:schemas-upnp-org:service:AVTransport:1", {
						InstanceID: 0
					});
				}
			}
         UpdateContent(-1, "Music Sources");     
		}

		/**
		 * Select group
		 * @param in_index
		 */
		function SelectGroup(in_index) {
			artist.Text = "";
			track.Text = "";
			album.Text = "";
			art.GetState(0).Image = "pic 640x528.png";
			if (groups.length == 0) {
				debug('groups.length == 0');
            UpdateGroups();
				return;
			}

			if (in_index >= groups.length) {
				debug(in_index + ' >= ' + groups.length);
				selected_zone = 0;
				in_index = 0;
			}

			HighLightSelectedZone(in_index);

			group = groups[in_index];
			zone.Text = group.name;
			// Re-subscribe to the events to get the current status of player
			UnSubscribe(group.parent);
			Subscribe(group.parent);
			ToggleOpenVolumeGroup(group.members.length > 0);
         gplaylist.Adapter.request = false;
         gplaylist.Adapter.GetItem(100); 
		}

		/**
		 * Add to playlist
		 */
		function AddToPlaylist() {
			var l_selected = glist.GetSelected();
			for (var i = 0; i < l_selected.length; ++i) {
				var l_content = glist.Adapter.content[l_selected[i]];
				group.parent.InvokeAction("AddURIToQueue", "urn:schemas-upnp-org:service:AVTransport:1",
					{
						InstanceID: 0,
						EnqueuedURI: l_content.res,
						EnqueuedURIMetaData: "",
						DesiredFirstTrackNumberEnqueued: 0,
						EnqueueAsNext: 1
					});
				// Clear selection
				//list.CreateItem(i, 0, {FillColor: gui.playlistCol0});
				//list.CreateItem(i, 5, {Value: 0});                  
			}
			glist.ClearSelected();
		}

		/**
		 * Add to favorites
		 */
		function AddToFavorites() {
         favorites.Visible = false;
			var l_select = glist.GetSelected();
			glist.ClearSelected();
			for (var i = 0; i < l_select.length; ++i) {
				var parent;
				if (/^SQ/.test(glist.Adapter.content[l_select[i]]["@id"])) {
					parent = "SQ:";
				}
				var l_elements
				if(glist.Adapter.content[l_select[i]]["type"] != "Radio"){
					l_elements = "&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item&gt;" +
					"&lt;dc:title&gt;" + escapeHTML(glist.Adapter.content[l_select[i]]["dc:title"], 1) + "&lt;/dc:title&gt;" +
					"&lt;res protocolInfo=&quot;x-file-cifs:*:audio/mpeg:*&quot;&gt;" + glist.Adapter.content[l_select[i]].res + "&lt;/res&gt;" +
					"&lt;r:type&gt;instantPlay&lt;/r:type&gt;" +
					"&lt;r:resMD&gt;&amp;lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot;    xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot;    xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;    xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&amp;quot;&amp;gt;" +
					"&amp;lt;item id=&amp;quot;" + escapeHTML(glist.Adapter.content[l_select[i]]["@id"]) + "&amp;quot; parentID=&amp;quot;"
					+ escapeHTML(glist.Adapter.content[l_select[i]]["@id"]).replace(/\/$/, "") + "&amp;quot; restricted=&amp;quot;true&amp;quot;&amp;gt;" +
					"&amp;lt;dc:title&amp;gt;" + escapeHTML(glist.Adapter.content[l_select[i]]["dc:title"], 2) + "&amp;lt;/dc:title&amp;gt;" +
					"&amp;lt;upnp:class&amp;gt;" + glist.Adapter.content[l_select[i]]["upnp:class"] + "&amp;lt;/upnp:class&amp;gt;" +
					"&amp;lt;desc id=&amp;quot;cdudn&amp;quot; nameSpace=&amp;quot;urn:schemas-rinconnetworks-com:metadata-1-0/&amp;quot;&amp;gt;" + 
					"RINCON_AssociatedZPUDN&amp;lt;/desc&amp;gt;&amp;lt;/item&amp;gt;&amp;lt;/DIDL-Lite&amp;gt;" +
					"&lt;/r:resMD&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;"	
				}else{
					l_elements = "&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item&gt;" +
					"&lt;dc:title&gt;" + escapeHTML(glist.Adapter.content[l_select[i]]["dc:title"], 1) + "&lt;/dc:title&gt;" +
					"&lt;res protocolInfo=&quot;x-file-cifs:*:audio/mpeg:*&quot;&gt;" + glist.Adapter.content[l_select[i]].res + "&lt;/res&gt;" +
					"&lt;r:type&gt;instantPlay&lt;/r:type&gt;" +
					"&lt;r:resMD&gt;&amp;lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot;    xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot;    xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;    xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&amp;quot;&amp;gt;" +
					"&amp;lt;item restricted=&amp;quot;true&amp;quot;&amp;gt;" +
					"&amp;lt;dc:title&amp;gt;" + escapeHTML(glist.Adapter.content[l_select[i]]["dc:title"], 2) + "&amp;lt;/dc:title&amp;gt;" +
					"&amp;lt;upnp:class&amp;gt;object.item.audioItem.audioBroadcast&amp;lt;/upnp:class&amp;gt;" +
					"&amp;lt;/item&amp;gt;&amp;lt;/DIDL-Lite&amp;gt;" +
					"&lt;/r:resMD&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;"				
				}												
				group.parent.InvokeAction("CreateObject", "urn:schemas-upnp-org:service:ContentDirectory:1", {
					ContainerID: "FV:2",
					Elements: l_elements
				});
			}
			select.length = 0;
		}

		/**
		 * Delete selected objects
		 */
		function DeleteObjects() {
			var l_select = glist.GetSelected();
			if (l_select.length == 0) {
				// remove поумолчанию невидим, соединить его с иконокой TODO
				//IR.ShowPopup(gui.mask);
				IR.ShowPopup(gui.warning_popup);
				GetItem(gui.warning_msg).Text = "Plese select songs for delete";
			}

			for (var i = 0; i < l_select.length; i++) {
				group.parent.InvokeAction("DestroyObject", "urn:schemas-upnp-org:service:ContentDirectory:1", {
					ObjectID: glist.Adapter.content[l_select[i]]["F_id"]
				});
			}

			// Update list
			IR.SetTimeout(500, function () {
				var l_folder = history.pop();
				UpdateContent(l_folder.id, l_folder.name);
			});
		}

      /**
		 * Show time
		 * @param in_bool
		 */
		function ShowTime(in_bool) {			
			timeleft.Visible = in_bool;
			timepast.Visible = in_bool;
			timeline.Visible = in_bool;
         timevis.Visible = in_bool;
		}

		/**
		 * Receive event
		 * @param in_type
		 * @param in_text
		 */
		function ReceiveEvent(in_type, in_text) {
			var l_xml = new XML(in_text);
			_event = undefined;

         //AVTransportURI
			try{
				_uri = l_xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.AVTransportURI["@val"];
			} catch (e) {}

			// Monitor changes in the groups
			try {
				var l_uri = l_xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.CurrentTrackURI["@val"];
				if ((this.group && this.group.uri != l_uri) ||
					(!this.group && l_uri.indexOf("x-rincon:") >= 0))
					UpdateGroups();
			} catch (error) {

			}
			// Volume
			try {
				var l_volume_val = l_xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.Volume["@val"];           
				try {
					volume_group_list.CreateItem(GetPlayerIndex(this), 7, {
						Text: l_volume_val + "%"
					});
				} catch (e) {
				}
				// save volume to players[i]
				this.player_volume = parseInt(l_volume_val);

				var group_vol = CalcGroupVolume(group);
				volume.Value = group_vol;
				percent.Text = group_vol + '%';

			} catch (error) {

			}
			// Mute
			try {
				var l_mute_val = l_xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.Mute["@val"];
				// создаем параметр объекту
				this.mute_val = l_mute_val;
				try {
					volume_group_list.CreateItem(GetPlayerIndex(this), 1, {
						Value: l_mute_val
					});
				} catch (e) {

				}
				if (group && group.parent == this) {
					mute.Value = l_mute_val;
				}

			} catch (error) {

			}
			// Play, Pause, Stopped
			try {
				var l_tr_state = l_xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.TransportState["@val"];
				var l_tr_val = 2; // Stop ???
				switch (l_tr_state) {
					case "PLAYING":
						l_tr_val = 0;
						break;
					case "PAUSED_PLAYBACK":
						l_tr_val = 1;
						break;
					case "STOPPED":
						l_tr_val = 1;
						timeleft.Text = '0:00:00';
						timepast.Text = '0:00:00';
						break;
					default:
					{
						l_tr_val = 2;
						break;
					}
				}

				if (group && group_created == true) {
					var l_gr_indx = GetGroupIndex(this);
					//debug("group " + group + " gr_indx " + gr_indx );
					if (typeof l_gr_indx == "number") {
						try {
							grouplist.CreateItem(l_gr_indx, 6, {
								State: l_tr_val
							});
						} catch (e) {

						}
					}
				}

				if (group && group.parent == this) {
					switch (l_tr_state) {
						case "PLAYING":
							play.Value = 1;
							break;
						case "TRANSITIONING":
							/*NOP*/      //впилить когда будет переходящее состояние
							break;
						case "STOPPED":
							play.Value = 0;
							break;
						case "PAUSED_PLAYBACK":
							play.Value = 0;
							break;
					}
				}
			} catch (error) {
			}

			// Changes in current group
			if (group && group.parent == this) {
				if (in_type == "urn:schemas-upnp-org:service:ContentDirectory:1") {
					UpdatePlaylist();
				} else {
					try {
                  var l_aaa = l_xml["e:propertyset"]["e:property"][1].ContainerUpdateIDs;
                  if(l_aaa){
                     if(l_aaa.toString().indexOf("Q:0") == 0){
                        IR.Log("update")
                        UpdatePlaylist();
                     }
                  }
						var l_vars = l_xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID;
						if (l_vars.CurrentPlayMode) {
							// TODO may be use map?
							switch (l_vars.CurrentPlayMode["@val"]) {
								case "NORMAL":
									shuffle.Value = 0;
									repeat.Value = 0;
									break;
								case "REPEAT_ALL":
									shuffle.Value = 0;
									repeat.Value = 1;
									break;
								case "SHUFFLE_NOREPEAT":
									shuffle.Value = 1;
									repeat.Value = 0;
									break;
								case "SHUFFLE":
									shuffle.Value = 1;
									repeat.Value = 1;
									break;
							}
						}
						if (l_vars.CurrentTrackDuration) {
							var l_timeArr = l_vars.CurrentTrackDuration["@val"].split(':');
							duration = l_timeArr[0] * 3600 + l_timeArr[1] * 60 + l_timeArr[2] * 1;
							// Request current position
							group.parent.InvokeAction("GetPositionInfo", "urn:schemas-upnp-org:service:AVTransport:1", {
									InstanceID: 0
								},
								function (in_text) {
									var l_xml = new XML(in_text);
									try {
										var l_response = l_xml["s:Envelope"]["s:Body"]["u:GetPositionInfoResponse"];
										//timepast.Text = response.RelTime.toString();
										var l_timeArr = l_response.RelTime.toString().split(':');
										position = l_timeArr[0] * 3600 + l_timeArr[1] * 60 + l_timeArr[2] * 1;
										timeline.Value = position * 100 / duration;
										// Remaining time
										date.setTime(position * 1000);
										var l_pasttime = ((duration - position) > 0) ? (duration - position) * 1000 : 0;
										date2.setTime(l_pasttime);
										timepast.Text = "-" + date2.getUTCHours() + ((date2.getUTCMinutes() < 10) ? ":0" : ":") + date2.getUTCMinutes() + ((date2.getUTCSeconds() < 10) ? ":0" : ":") + date2.getUTCSeconds();
										timeleft.Text = "" + date.getUTCHours() + ((date.getUTCMinutes() < 10) ? ":0" : ":") + date.getUTCMinutes() + ((date.getUTCSeconds() < 10) ? ":0" : ":") + date.getUTCSeconds();
									} catch (error) {

									}
								});
						}
						if (l_vars.CurrentTrack) {
							current = l_vars.CurrentTrack["@val"];
							// отображение количества песен в плейлисте
							if(current <= gplaylist.Adapter.total){
								GetItem(gui.count).Text = current + " of " + gplaylist.Adapter.total;
							}
							//playlist.SetPosition(current-1);
						}
						if (l_vars["r:EnqueuedTransportURIMetaData"]) {
							if (l_vars["r:EnqueuedTransportURIMetaData"]["@val"]) {
								var l_xml2 = new XML(l_vars["r:EnqueuedTransportURIMetaData"]["@val"]);
								l_xml2 = l_xml2["DIDL-Lite"];
								if (l_xml2) {
									l_xml2 = l_xml2.item;
									if (l_xml2["upnp:class"] == "object.item.audioItem.audioBroadcast") {
										track.Text = l_xml2["dc:title"] || "";
										artist.Text = "Radio";
                              album.Text = "";
										ShowTime(false);
									}
								}
							}
							if (l_vars["TransportErrorDescription"]) {
								//IR.ShowPopup(gui.mask);
								IR.ShowPopup(gui.warning_popup);
								GetItem(gui.warning_msg).Text = "Song " + l_vars["TransportErrorURI"]["@val"].substr(12) + " not found!";
							}
						}
					} catch (error) {
						IR.Log(error)
					}
					
				}
			}
			// Track, Artist, Album
			try {
				//IR.Log(l_xml.toXMLString())
				var track_data = l_xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.CurrentTrackMetaData;
				if (track_data["@val"]) {
					var l_xml2 = new XML(track_data["@val"]);
					l_xml2 = l_xml2["DIDL-Lite"];
					if (l_xml2) {						
						try {
							if (group && group_created) {
								var gr_indx = GetGroupIndex(this);
								if (typeof gr_indx == "number") {
									l_xml2 = l_xml2.item;   
                           if(l_xml2["res"].toString().indexOf("x-sonosapi-stream:")==-1){                     
   									var l_track = (l_xml2["dc:title"]) ? l_xml2["dc:title"].toString() : "";       
   									var l_artist = (l_xml2["dc:creator"]) ? l_xml2["dc:creator"].toString() : "";
   									var l_album = (l_xml2["upnp:album"]) ? l_xml2["upnp:album"].toString() : "";
   									if (l_xml2["r:streamContent"].toString())
   										l_track = l_xml2["r:streamContent"];
   									try {
   										grouplist.CreateItem(gr_indx, 8, {
   											Text: l_track
   										});
   										grouplist.CreateItem(gr_indx, 7, {
   											Text: l_artist
   										});
   										grouplist.CreateItem(gr_indx, 9, {
   											Text: l_album
   										});
   									} catch (e) {
   									}
                           }
								}
							}
						} catch (e) {
						}
						try {
							if (group && group.parent == this) {
                        if(l_track)
								 track.Text = l_track;
                        if(l_artist)
								 artist.Text = l_artist;
                        if(l_album)
								 album.Text = l_album;
                        if(artist.Text != "Radio"){
   								ShowTime(true);
                        }
								var l_uri = l_xml2["upnp:albumArtURI"];
								art.GetState(0).Image = (l_uri) ? "http://" + group.parent.Host + ":" + group.parent.Port + l_uri : "pic 640x528.png";
							}
							if (/x\-rincon\-(mp3radio|stream)\:/.test(xml["e:propertyset"]["e:property"].LastChange.Event.InstanceID.CurrentTrackURI["@val"])) {
								try {
									ShowTime(false);
								} catch (e) {
								}
							}
						}
						catch (e) {
						}
						try{
							if(l_xml2.toXMLString().indexOf('<res protocolInfo="x-rincon-stream:*:*:*">x-rincon-stream:')!=-1){
									ShowTime(false);
							}else{
                        if(artist.Text != "Radio"){
   								//ShowTime(true);
                        }
							}
						} catch (e){}
					}
				}
			} catch (e) {
			}
		}

		/**
		 * Group invoke action
		 * @param in_time
		 * @param in_service
		 * @param in_args
		 */
		function GroupInvokeAction(in_action, in_service, in_args) {
			// Parent
			group.parent.InvokeAction(in_action, in_service, in_args);

			// Members
			for (var i = 0; i < group.members.length; ++i)
				group.members[i].InvokeAction(in_action, in_service, in_args);
		}

		/**
		 * Save players
		 */
		function SavePlayers() {
			var l_data = [];
			for (var i = 0; i < players.length; ++i)
				l_data[i] = players[i].Name + '~http://' + players[i].Host + ':' + players[i].Port + players[i].DescriptionUrl;
			IR.SetVariable("Global.SonosPlayers", l_data.join(','));
		}

		/**
		 * Load players
		 */
		function LoadPlayers() {
			var l_data = IR.GetVariable("Global.SonosPlayers");
			if (l_data) {
				l_data = l_data.split(',');
				// Simulate found device
				for (var i = 0; i < l_data.length; ++i) {
					var player = l_data[i].split('~');
					FoundDevice(player[0], player[1]);
				}
			}
		}
		
		/**
		 * Get item
		 * @param in_path
		 * @returns {Item}
		 */
		function GetItem(in_path) {
         if(!in_path)
            IR.Log("Warning: GetItem(undefined)")
			in_path = in_path.split('.');
			// Find parent
			var parent = IR.GetItem(in_path[0]);
			// Find child
			return in_path.length > 1 ? parent.GetItem(in_path[1]): parent;
		}

		/**
		 * Work for timeline
		 * @param in_time
		 */
		function Work(in_time) {
			in_time /= 1000; // to seconds
			if (play.Value) {
				// Prediction
				position += in_time;
				if (!timeline.lock) {
					timeline.Value = position * 100 / duration;	
				}
				// Remaining time
				date.setTime(position * 1000);
				var l_pasttime = ((duration - position) > 0) ? (duration - position) * 1000 : 0;
				date2.setTime(l_pasttime);
				timepast.Text = "-" + date2.getUTCHours() + ((date2.getUTCMinutes() < 10) ? ":0" : ":") + date2.getUTCMinutes() + ((date2.getUTCSeconds() < 10) ? ":0" : ":") + date2.getUTCSeconds();
				timeleft.Text = "" + date.getUTCHours() + ((date.getUTCMinutes() < 10) ? ":0" : ":") + date.getUTCMinutes() + ((date.getUTCSeconds() < 10) ? ":0" : ":") + date.getUTCSeconds();
			}
		}

		/**
		 * Show OpenVolumeGroup button
		 * @param in_state
		 */
		function ToggleOpenVolumeGroup(in_state) {
			GetItem(gui.open_volume_group).Visible = in_state;
			GetItem(gui.open_volume_group).Enable = in_state;
		}

		 /**
		 * Show delete button
		 * @param in_state
		 */
		function ToggleDeleteButton(in_state) {
			GetItem(gui.deleteb).Visible = in_state;
			GetItem(gui.deleteb).Enable = in_state;
		}

		 /**
		 * Selected zone
		 * @param in_index
		 */
		function HighLightSelectedZone(in_index) {
			// turn off previous zone
			if (selected_zone != in_index)
				grouplist.CreateItem(selected_zone, 1, {
					Value: 0
				});
			// enable selected zone
			grouplist.CreateItem(in_index, 1, {
				Value: 1
			});
			selected_zone = in_index;
		}

		 /**
		 * Get player index
		 * @param in_player
		 * @returns {Int}
		 */
		function GetPlayerIndex(in_player) {
			for (i in players)
				if (players[i] == in_player)
					return parseInt(i);
		}

		 /**
		 * Get group index
		 * @param in_player
		 * @returns {Int}
		 */
		function GetGroupIndex(in_player) {
			for (i in groups){
				try{
					if (groups[i].parent == in_player){        
						return parseInt(i);
					}
				}catch(e){}
					
			}
		}

		/**
		 * Subscribe
		 * @param in_player
		 */
		function Subscribe(in_player) {
			in_player.Subscribe("urn:schemas-upnp-org:service:AVTransport:1");
			in_player.Subscribe("urn:schemas-upnp-org:service:RenderingControl:1");
			in_player.Subscribe("urn:schemas-upnp-org:service:ContentDirectory:1");
		}

		/**
		 * Unsubscribe
		 * @param in_player
		 */
		function UnSubscribe(in_player) {
			in_player.Unsubscribe("urn:schemas-upnp-org:service:AVTransport:1");
			in_player.Unsubscribe("urn:schemas-upnp-org:service:RenderingControl:1");
			in_player.Unsubscribe("urn:schemas-upnp-org:service:ContentDirectory:1");
		}

		/**
		 * debug
		 * @param in_text
		 */
		function debug(in_text) {
			IR.Log("Debug: " + in_text);
		}

		/**
		 * print XMLObject
		 *///Временно бесполезна
		function printXMLObject() {
			debug(">printObject");
			debug("<printObject");
		}
		
		/**
		 * print object
		 * @param in_object
		 */
		function printObject(in_object) {
			debug(">printObject");
			debug(in_object);
			for (key in in_object) {
				if (typeof in_object[key] == 'object')
					printObject(in_object[key]);
			}
			debug("<printObject");
		}

		 /**
		 * Play back
		 * @param in_title
		 * @param in_uri
		 * @param in_speed
       * @param in_seek
		 */
      var _allReceive = true;
		function PlayBack(in_title, in_uri, in_speed, in_seek) {
         if(_allReceive){
            _allReceive = false;
   			var l_meta = '&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; ';
   			l_meta += 'xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; ';
   			l_meta += 'xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; ';
   			l_meta += 'xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;';
   			l_meta += '&gt;&lt;item id=&quot;-1&quot; ';
   			l_meta += 'parentID=&quot;-1&quot; ';
   			l_meta += 'restricted=&quot;true&quot;&gt;';
   			l_meta += '&lt;dc:title&gt;' + escapeHTML(in_title) + '&lt;/dc:title&gt;';
   			l_meta += '&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;';
   			l_meta += '&lt;desc id=&quot;cdudn&quot; ';
   			l_meta += 'nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;SA_RINCON65031_';
   			l_meta += '&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;';
            if(in_uri != _uri){                 
					group.parent.InvokeAction("SetAVTransportURI", "urn:schemas-upnp-org:service:AVTransport:1", {
      				InstanceID: 0,
      				CurrentURI: in_uri,
      				CurrentURIMetaData: l_meta
      			}); 
               _uri = in_uri;    
            }
   			  
            if(in_seek)
      			group.parent.InvokeAction("Seek", "urn:schemas-upnp-org:service:AVTransport:1",
      				{InstanceID: 0, Unit: "TRACK_NR", Target: gplaylist.Adapter.total});
   			group.parent.InvokeAction("Play", "urn:schemas-upnp-org:service:AVTransport:1", {
   				InstanceID: 0,
   				Speed: in_speed
   			}, function(){_allReceive = true});
         }
		}

		/**
		 * Calc group volume
		 * @param in_group
		 * @returns {Int}
		 */
		function CalcGroupVolume(in_group) {
			var l_amean = in_group.parent.player_volume;
			for (var i = 0; i < in_group.members.length; i++)
				l_amean += in_group.members[i].player_volume;

			return Math.round(l_amean / (in_group.members.length + 1));
		}

		/**
		 * Get average
		 * @param in_vol
		 * @param in_inc
		 * @returns {Int}
		 */
		function GetAverage(in_vol, in_inc) {
			return (in_vol * in_inc - 100 > 0) ? in_vol * in_inc - 100 : 0;
		}

		/**
		 * Calc average
		 * @param in_group
		 * @param in_inc_mean
		 * @returns {Int}
		 */
		function CalcAverage(in_group, in_inc_mean) {
			var l_aver = GetAverage(in_group.parent.player_volume, in_inc_mean);
			if (l_aver)
				return l_aver;
			for (var i = 0; i < in_group.members.length; i++) {
				l_aver = GetAverage(in_group.members[i].player_volume, in_inc_mean);
				if (l_aver)
					return l_aver;
			}
			return l_aver;
		}

		/**
		 * Calc new vol
		 * @param in_v
		 * @param in_inc
		 * @param in_aver
		 * @returns {Int}
		 */
		function CalcNewVol(in_v, in_inc, in_aver) {
			var l_nvol = in_v ? in_v * in_inc : in_inc;
			l_nvol = (l_nvol > 100) ? 100 : l_nvol;
			l_nvol = (l_nvol < 50 && in_aver > 5) ? l_nvol + in_aver : l_nvol;
			return l_nvol;
		}

		/**
		 * Calc new vol
		 * @param in_method
		 * @param in_path
		 * @param in_host
		 * @param in_action
		 * @param in_id
		 * @returns {[]String}
		 */
		function FormInvokeAction(in_method, in_path, in_host, in_action, in_id) {
			var l_sid = 'fr1PvlmTHL52d3c6d1de34f5Gj7Np4O52d3c6d1de38edSkOQU';
			var l_uid = '411385351'; //'411385351';
			var l_body = '<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">';
			l_body += '<s:Header>';
			l_body += '<credentials xmlns="http://www.sonos.com/Services/1.1">';
			l_body += '<sessionId>' + l_sid + ':0:' + l_uid + '</sessionId>';
			l_body += '<deviceId>00-0E-58-3B-37-C2:5</deviceId>';
			l_body += '<deviceProvider>Sonos</deviceProvider>';
			l_body += '</credentials>';
			l_body += '</s:Header>';
			l_body += '<s:Body>';
			l_body += '<' + in_action + ' xmlns="http://www.sonos.com/Services/1.1">';
			l_body += '<id>' + in_id + '</id>';
			l_body += '<index>0</index>';
			l_body += '<count>100</count>';
			l_body += '</' + in_action + '>';
			l_body += '</s:Body>';
			l_body += '</s:Envelope>';

			// create header
			var l_header = in_method + " " + in_path + " HTTP/1.1" + "\r\n";
			l_header += 'CONNECTION: close\r\n';
			l_header += 'ACCEPT-ENCODING: gzip\r\n';
			l_header += 'HOST: ' + in_host + '\r\n'; //deezer.ws.sonos.com
			l_header += 'USER-AGENT: Linux UPnP/1.0 Sonos/24.0-69180m (WDCR:Microsoft Windows NT 6.1.7600.0)\r\n';
			l_header += 'CONTENT-LENGTH: ' + l_body.length + '\r\n';
			l_header += 'CONTENT-TYPE: text/xml; charset="utf-8"\r\n';
			l_header += 'ACCEPT-LANGUAGE: en-US\r\n';
			l_header += 'SOAPACTION: "http://www.sonos.com/Services/1.1#' + in_action + '"\r\n'; // getMetadata

			var l_request = l_header + '\r\n' + l_body + '\r\n';
			return [l_request];
		}
	};
